## spatialindex 1.7.0

=== CMakeLists.txt ===
#
# top-level CMake configuration file for PDAL
#
# (based originally on the libLAS files copyright Mateusz Loskot)

cmake_minimum_required(VERSION 2.6.0)
project(spatialindex)

#------------------------------------------------------------------------------
# internal cmake settings
#------------------------------------------------------------------------------

set(CMAKE_COLOR_MAKEFILE ON)

# Allow advanced users to generate Makefiles printing detailed commands
mark_as_advanced(CMAKE_VERBOSE_MAKEFILE)

# Path to additional CMake modules
set(CMAKE_MODULE_PATH ${PROJECT_SOURCE_DIR}/cmake/modules ${CMAKE_MODULE_PATH})


#------------------------------------------------------------------------------
# libspatialindex general settings
#------------------------------------------------------------------------------

SET(SIDX_VERSION_MAJOR "1")
SET(SIDX_VERSION_MINOR "7")
SET(SIDX_VERSION_PATCH "0")

set(SIDX_VERSION_STRING "${SIDX_VERSION_MAJOR}.${SIDX_VERSION_MINOR}.${SIDX_VERSION_PATCH}")
SET(SIDX_LIB_SOVERSION ${SIDX_VERSION_MAJOR})
SET(SIDX_C_LIB_SOVERSION ${SIDX_VERSION_MAJOR})


# Name of C++ library
set(SIDX_LIB_NAME spatialindex)

set(SIDX_C_LIB_NAME spatialindex_c)

set(CMAKE_INCLUDE_DIRECTORIES_PROJECT_BEFORE ON)

include (CheckFunctionExists)

check_function_exists(srand48 HAVE_SRAND48)
check_function_exists(gettimeofday HAVE_GETTIMEOFDAY)
check_function_exists(bzero HAVE_BZERO)
check_function_exists(memset HAVE_MEMSET)
check_function_exists(memcpy HAVE_MEMCPY)
check_function_exists(bcopy HAVE_BCOPY)

if (HAVE_SRAND48)
    add_definitions(-DHAVE_SRAND48=1)
endif()

if (HAVE_GETTIMEOFDAY)
    add_definitions(-DHAVE_GETTIMEOFDAY=1)
endif()

if (HAVE_BZERO)
    add_definitions(-DHAVE_BZERO=1)
endif()

if (HAVE_MEMSET)
    add_definitions(-DHAVE_MEMSET=1)
endif()

if (HAVE_MEMCPY)
    add_definitions(-DHAVE_MEMCPY=1)
endif()

if (HAVE_BCOPY)
    add_definitions(-DHAVE_BCOPY=1)
endif()

# Choose to use pkg-config or not
#set(WITH_PKGCONFIG FALSE CACHE BOOL
#  "Choose whether a pkgconfig file (PDAL.pc) should be installed")

#------------------------------------------------------------------------------
# General build settings
#------------------------------------------------------------------------------

# note we default to debug mode
if(NOT MSVC_IDE)
  if(NOT CMAKE_BUILD_TYPE)
  set(CMAKE_BUILD_TYPE Debug CACHE STRING 
    "Choose the type of build, options are: None Debug Release RelWithDebInfo MinSizeRel" FORCE)
  endif()
  message(STATUS "Setting libspatialindex build type - ${CMAKE_BUILD_TYPE}")
endif()

set(SIDX_BUILD_TYPE ${CMAKE_BUILD_TYPE})

# TODO: Still testing the output paths --mloskot
set(SIDX_BUILD_OUTPUT_DIRECTORY ${PROJECT_BINARY_DIR}/bin)

# Output directory in which to build RUNTIME target files.
set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${SIDX_BUILD_OUTPUT_DIRECTORY})

# Output directory in which to build LIBRARY target files
set(CMAKE_LIBRARY_OUTPUT_DIRECTORY ${SIDX_BUILD_OUTPUT_DIRECTORY})

# Output directory in which to build ARCHIVE target files.
set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY ${SIDX_BUILD_OUTPUT_DIRECTORY}) 


#------------------------------------------------------------------------------
# Platform and compiler specific settings
#------------------------------------------------------------------------------

if(WIN32)
  if (MSVC)
    if (MSVC80 OR MSVC90 OR MSVC10)
      add_definitions(-D_CRT_SECURE_NO_DEPRECATE)
      add_definitions(-D_CRT_SECURE_NO_WARNINGS)
      add_definitions(-D_CRT_NONSTDC_NO_WARNING)
      add_definitions(-D_SCL_SECURE_NO_WARNINGS)
      add_definitions(-DSPATIALINDEX_CREATE_DLL=1)

      set(SIDX_COMPILER_MSVC 1)
      if (MSVC10)
        set(SIDX_COMPILER_VC10 1)
      elseif (MSVC9)
        set(SIDX_COMPILER_VC9 1)
      elseif (MSVC8)
        set(SIDX_COMPILER_VC8 1)
      endif()
    endif()
    
    if(CMAKE_CXX_FLAGS MATCHES "/W[0-4]")
      string(REGEX REPLACE "/W[0-4]" "/W4"
        CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS}")
    else()
      set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /W4")
    endif()
  endif()
  
  set(CMAKE_INCLUDE_PATH c:/osgeo4w/include;$ENV{CMAKE_INCLUDE_PATH})
  set(CMAKE_LIBRARY_PATH c:/osgeo4w/lib;$ENV{CMAKE_LIBRARY_PATH})

  set(SIDX_OS_WIN32 1)

else()
  # not WIN32

  # Recommended C++ compilation flags
  # -Weffc++
  set(SIDX_COMMON_CXX_FLAGS
    "-pedantic -Wall -Wpointer-arith -Wcast-align -Wcast-qual  -Wredundant-decls -Wno-long-long")

  if(CMAKE_COMPILER_IS_GNUCC OR CMAKE_COMPILER_IS_GNUCXX)

    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${SIDX_COMMON_CXX_FLAGS}")
    if (CMAKE_COMPILER_IS_GNUCXX)
      set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++98 -ansi")
    endif()
    
    set(SIDX_COMPILER_GCC 1)
    
  elseif("${CMAKE_CXX_COMPILER_ID}" MATCHES "Clang" OR "${CMAKE_CXX_COMPILER}" MATCHES "clang")
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${SIDX_COMMON_CXX_FLAGS}")
    set(SIDX_COMPILER_CLANG 1)
  endif()
endif(WIN32)

if (APPLE)
  set(SO_EXT dylib)
  set(CMAKE_FIND_FRAMEWORK "LAST")
elseif(WIN32)
  set(SO_EXT dll)
else()
  set(SO_EXT so)
endif(APPLE)


#------------------------------------------------------------------------------
# installation path settings
#------------------------------------------------------------------------------

if(WIN32)
  set(DEFAULT_LIB_SUBDIR lib)
  set(DEFAULT_DATA_SUBDIR .)
  set(DEFAULT_INCLUDE_SUBDIR include)

  if (MSVC)
    set(DEFAULT_BIN_SUBDIR bin)
  else()
    set(DEFAULT_BIN_SUBDIR .)
  endif()
else()
  # Common locations for Unix and Mac OS X
  set(DEFAULT_BIN_SUBDIR bin)
  set(DEFAULT_LIB_SUBDIR lib${LIB_SUFFIX})
  set(DEFAULT_DATA_SUBDIR share/libspatialindex)
  set(DEFAULT_INCLUDE_SUBDIR include)
endif()

# Locations are changeable by user to customize layout of SIDX installation
# (default values are platform-specific)
set(SIDX_BIN_SUBDIR ${DEFAULT_BIN_SUBDIR} CACHE STRING
  "Subdirectory where executables will be installed")
set(SIDX_LIB_SUBDIR ${DEFAULT_LIB_SUBDIR} CACHE STRING
  "Subdirectory where libraries will be installed")
set(SIDX_INCLUDE_SUBDIR ${DEFAULT_INCLUDE_SUBDIR} CACHE STRING
  "Subdirectory where header files will be installed")
set(SIDX_DATA_SUBDIR ${DEFAULT_DATA_SUBDIR} CACHE STRING
  "Subdirectory where data will be installed")

# Mark *_SUBDIR variables as advanced and dedicated to use by power-users only.
mark_as_advanced(SIDX_BIN_SUBDIR
  SIDX_LIB_SUBDIR SIDX_INCLUDE_SUBDIR SIDX_DATA_SUBDIR)

# Full paths for the installation
set(SIDX_BIN_DIR ${SIDX_BIN_SUBDIR})
set(SIDX_LIB_DIR ${SIDX_LIB_SUBDIR})
set(SIDX_INCLUDE_DIR ${SIDX_INCLUDE_SUBDIR})
set(SIDX_DATA_DIR ${SIDX_DATA_SUBDIR})


#------------------------------------------------------------------------------
# subdirectory controls
#------------------------------------------------------------------------------

add_subdirectory(src)
add_subdirectory(test)




#------------------------------------------------------------------------------
# finally, generate the pdal_config.h header
#------------------------------------------------------------------------------
# 
# configure_file(
#   "${PROJECT_SOURCE_DIR}/pdal_defines.h.in"
#   "${PROJECT_SOURCE_DIR}/include/pdal/pdal_defines.h")

=== src/CMakeLists.txt ===
###############################################################################
#
# src/CMakeLists.txt controls building of SIDX library
#
# Copyright (c) 2009 Mateusz Loskot <mateusz@loskot.net>
#
###############################################################################

###############################################################################
# Source files specification
#
# Naming format:
#   SIDX_CPP - all the .cpp files
#   SIDX_HPP - all the .hpp files
#   SIDX_<dirname>_CPP - all the .cpp files for the given subdir/namespace
#   ...

set(SIDX_HEADERS_DIR ${PROJECT_SOURCE_DIR}/include/spatialindex/)
set(SIDX_HEADERS_CAPI_DIR ${PROJECT_SOURCE_DIR}/include/spatialindex/capi)
set(SIDX_HPP "")
set(SIDX_CPP "")

set(SIDX_SRC_DIR ${PROJECT_SOURCE_DIR}/src)
set(SIDX_CAPI_DIR ${PROJECT_SOURCE_DIR}/src/capi)

#
# base
#
set(SIDX_BASE_HPP
  ${SIDX_HEADERS_DIR}/LineSegment.h
  ${SIDX_HEADERS_DIR}/MovingPoint.h
  ${SIDX_HEADERS_DIR}/MVRTree.h
  ${SIDX_HEADERS_DIR}/Point.h
  ${SIDX_HEADERS_DIR}/Region.h
  ${SIDX_HEADERS_DIR}/RTree.h
  ${SIDX_HEADERS_DIR}/SpatialIndex.h
  ${SIDX_HEADERS_DIR}/TimePoint.h
  ${SIDX_HEADERS_DIR}/TimeRegion.h
  ${SIDX_HEADERS_DIR}/TPRTree.h
  ${SIDX_HEADERS_DIR}/Version.h
)
list (APPEND SIDX_HPP ${SIDX_BASE_HPP} )

set(SIDX_CAPI_HPP
  ${SIDX_HEADERS_CAPI_DIR}/BoundsQuery.h
  ${SIDX_HEADERS_CAPI_DIR}/CountVisitor.h
  ${SIDX_HEADERS_CAPI_DIR}/CustomStorage.h
  ${SIDX_HEADERS_CAPI_DIR}/DataStream.h
  ${SIDX_HEADERS_CAPI_DIR}/Error.h
  ${SIDX_HEADERS_CAPI_DIR}/IdVisitor.h
  ${SIDX_HEADERS_CAPI_DIR}/Index.h
  ${SIDX_HEADERS_CAPI_DIR}/LeafQuery.h
  ${SIDX_HEADERS_CAPI_DIR}/ObjVisitor.h
  ${SIDX_HEADERS_CAPI_DIR}/sidx_api.h 
  ${SIDX_HEADERS_CAPI_DIR}/sidx_config.h 
  ${SIDX_HEADERS_CAPI_DIR}/sidx_impl.h
  ${SIDX_HEADERS_CAPI_DIR}/Utility.h
)
list (APPEND SIDX_HPP ${SIDX_CAPI_HPP} )

set(SIDX_CAPI_CPP
  ${SIDX_CAPI_DIR}/BoundsQuery.cc
  ${SIDX_CAPI_DIR}/CountVisitor.cc
  ${SIDX_CAPI_DIR}/CustomStorage.cc
  ${SIDX_CAPI_DIR}/DataStream.cc
  ${SIDX_CAPI_DIR}/Error.cc
  ${SIDX_CAPI_DIR}/IdVisitor.cc
  ${SIDX_CAPI_DIR}/Index.cc
  ${SIDX_CAPI_DIR}/LeafQuery.cc
  ${SIDX_CAPI_DIR}/ObjVisitor.cc
  ${SIDX_CAPI_DIR}/sidx_api.cc
  ${SIDX_CAPI_DIR}/Utility.cc
)


set(SIDX_SPATIALINDEX_CPP
  ${SIDX_SRC_DIR}/spatialindex/LineSegment.cc
  ${SIDX_SRC_DIR}/spatialindex/MovingPoint.cc
  ${SIDX_SRC_DIR}/spatialindex/MovingRegion.cc
  ${SIDX_SRC_DIR}/spatialindex/Point.cc
  ${SIDX_SRC_DIR}/spatialindex/Region.cc
  ${SIDX_SRC_DIR}/spatialindex/SpatialIndexImpl.cc
  ${SIDX_SRC_DIR}/spatialindex/TimePoint.cc
  ${SIDX_SRC_DIR}/spatialindex/TimeRegion.cc
)
list (APPEND SIDX_CPP ${SIDX_SPATIALINDEX_CPP} )

set(SIDX_MVRTREE_CPP
  ${SIDX_SRC_DIR}/mvrtree/Index.cc
  ${SIDX_SRC_DIR}/mvrtree/Index.h
  ${SIDX_SRC_DIR}/mvrtree/Leaf.cc
  ${SIDX_SRC_DIR}/mvrtree/Leaf.h
  ${SIDX_SRC_DIR}/mvrtree/MVRTree.cc
  ${SIDX_SRC_DIR}/mvrtree/MVRTree.h
  ${SIDX_SRC_DIR}/mvrtree/Node.cc
  ${SIDX_SRC_DIR}/mvrtree/Node.h
  ${SIDX_SRC_DIR}/mvrtree/PointerPoolNode.h
  ${SIDX_SRC_DIR}/mvrtree/Statistics.cc
  ${SIDX_SRC_DIR}/mvrtree/Statistics.h
)
list (APPEND SIDX_CPP ${SIDX_MVRTREE_CPP})

set(SIDX_RTREE_CPP
  ${SIDX_SRC_DIR}/rtree/BulkLoader.cc
  ${SIDX_SRC_DIR}/rtree/BulkLoader.h
  ${SIDX_SRC_DIR}/rtree/Index.cc
  ${SIDX_SRC_DIR}/rtree/Index.h
  ${SIDX_SRC_DIR}/rtree/Leaf.cc
  ${SIDX_SRC_DIR}/rtree/Leaf.h
  ${SIDX_SRC_DIR}/rtree/Node.cc
  ${SIDX_SRC_DIR}/rtree/Node.h
  ${SIDX_SRC_DIR}/rtree/PointerPoolNode.h
  ${SIDX_SRC_DIR}/rtree/RTree.cc
  ${SIDX_SRC_DIR}/rtree/RTree.h
  ${SIDX_SRC_DIR}/rtree/Statistics.cc
  ${SIDX_SRC_DIR}/rtree/Statistics.h
)
list (APPEND SIDX_CPP ${SIDX_RTREE_CPP})

set(SIDX_STORAGEMANAGER_CPP
  ${SIDX_SRC_DIR}/storagemanager/Buffer.cc
  ${SIDX_SRC_DIR}/storagemanager/DiskStorageManager.cc
  ${SIDX_SRC_DIR}/storagemanager/DiskStorageManager.h
  ${SIDX_SRC_DIR}/storagemanager/MemoryStorageManager.cc
  ${SIDX_SRC_DIR}/storagemanager/MemoryStorageManager.h
  ${SIDX_SRC_DIR}/storagemanager/RandomEvictionsBuffer.cc
  ${SIDX_SRC_DIR}/storagemanager/RandomEvictionsBuffer.h
)
list (APPEND SIDX_CPP ${SIDX_STORAGEMANAGER_CPP})

set(SIDX_RAND48 )

if (NOT HAVE_SRAND48)
    set(SIDX_RAND48 ${SIDX_SRC_DIR}/tools/rand48.cc)
endif()

set(SIDX_TOOLS_CPP
  ${SIDX_RAND48}
  ${SIDX_SRC_DIR}/tools/Tools.cc
)
list (APPEND SIDX_CPP ${SIDX_TOOLS_CPP})

set(SIDX_TOOLS_CPP
  ${SIDX_SRC_DIR}/tprtree/Index.cc
  ${SIDX_SRC_DIR}/tprtree/Index.h
  ${SIDX_SRC_DIR}/tprtree/Leaf.cc
  ${SIDX_SRC_DIR}/tprtree/Leaf.h
  ${SIDX_SRC_DIR}/tprtree/Node.cc
  ${SIDX_SRC_DIR}/tprtree/Node.h
  ${SIDX_SRC_DIR}/tprtree/PointerPoolNode.h
  ${SIDX_SRC_DIR}/tprtree/Statistics.cc
  ${SIDX_SRC_DIR}/tprtree/Statistics.h
  ${SIDX_SRC_DIR}/tprtree/TPRTree.cc
  ${SIDX_SRC_DIR}/tprtree/TPRTree.h
)
list (APPEND SIDX_CPP ${SIDX_TOOLS_CPP} )
#
# Group source files for IDE source explorers (e.g. Visual Studio)
#

source_group("CMake Files" FILES CMakeLists.txt)

source_group("Header Files" FILES ${SIDX_BASE_HPP})
source_group("C API Header Files" FILES ${SIDX_CAPI_HPP})

source_group("Source Files" FILES ${SIDX_BASE_CPP})
source_group("C API Source Files" FILES ${SIDX_CAPI_CPP})


# Standard include directory of SIDX library
include_directories(../include)

set (APPS_CPP_DEPENDENCIES "${SIDX_LIB_NAME}" CACHE INTERNAL "libraries to link")

###############################################################################
# Targets settings

set(SIDX_SOURCES
  ${SIDX_HPP}
  ${SIDX_CPP})

# NOTE:
# This hack is required to correctly link static into shared library.
# Such practice is not recommended as not portable, instead each library,
# static and shared should be built from sources separately.
#if(UNIX)
#  add_definitions("-fPIC")
#endif()

if(WIN32)
    add_definitions("-DSIDX_DLL_EXPORT=1")
if (NOT WITH_STATIC_LASZIP)
    add_definitions("-DLASZIP_DLL_IMPORT=1")
endif()
endif()

add_library(${SIDX_LIB_NAME} SHARED ${SIDX_SOURCES})

add_library(${SIDX_C_LIB_NAME} SHARED ${SIDX_CAPI_CPP})

target_link_libraries(${SIDX_C_LIB_NAME}
  ${SIDX_LIB_NAME}
)



set_target_properties(${SIDX_LIB_NAME}
  PROPERTIES SOVERSION "${SIDX_LIB_SOVERSION}" )

set_target_properties(${SIDX_C_LIB_NAME} 
  PROPERTIES SOVERSION "${SIDX_C_LIB_SOVERSION}" )



if (APPLE)
  set_target_properties(
    ${SIDX_LIB_NAME}
    PROPERTIES
    INSTALL_NAME_DIR "${CMAKE_INSTALL_PREFIX}/lib")
endif()

###############################################################################
# Targets installation

install(TARGETS ${SIDX_LIB_NAME} ${SIDX_C_LIB_NAME}
  RUNTIME DESTINATION ${SIDX_BIN_DIR}
  LIBRARY DESTINATION ${SIDX_LIB_DIR}
  ARCHIVE DESTINATION ${SIDX_LIB_DIR})

install(DIRECTORY ${SIDX_HEADERS_DIR}
  DESTINATION include/libspatialindex
  FILES_MATCHING PATTERN "*.h" PATTERN "*.hpp")

=== test/CMakeLists.txt ===
include_directories(../include)

set (DIR rtree)
set (SOURCES 
        Exhaustive
        Generator
        RTreeBulkLoad
        RTreeLoad
        RTreeQuery)


foreach (test ${SOURCES})
    add_executable(test-${DIR}-${test} ${DIR}/${test}.cc)
    target_link_libraries(test-${DIR}-${test} ${SIDX_LIB_NAME})
endforeach()

set (DIR mvrtree)
set (SOURCES 
        Exhaustive
        Generator
        MVRTreeLoad
        MVRTreeQuery
        )


foreach (test ${SOURCES})
    add_executable(test-${DIR}-${test} ${DIR}/${test}.cc)
    target_link_libraries(test-${DIR}-${test} ${SIDX_LIB_NAME})
endforeach()

set (DIR tprtree)
set (SOURCES 
        Exhaustive
        Generator
        TPRTreeLoad
        TPRTreeQuery
        )


foreach (test ${SOURCES})
    add_executable(test-${DIR}-${test} ${DIR}/${test}.cc ${DIR}/RandomGenerator.cc)
    target_link_libraries(test-${DIR}-${test} ${SIDX_LIB_NAME})
endforeach()

=== debian/changelog ===
spatialindex (1.7.0-1) unstable; urgency=low

  * New upstream release.
  * Changed homepage in debian/control.
  * Policy bumped to 3.9.2.
  * Moved to debian source 3.0 and quilt support.
  * Moved to git repository and changed Vcs-* fields as consequence.
  * Now using debhelper 8 as minimal level.
  * Now save and restore config.* helpers.
  * Now do not install libtool helper file and adds a pkg-config configuration
    file instead.

 -- Francesco Paolo Lovergine <frankie@debian.org>  Mon, 28 Nov 2011 14:54:34 +0100

spatialindex (1.5.0-1) unstable; urgency=low

  * New upstream release. 

 -- Francesco Paolo Lovergine <frankie@debian.org>  Mon, 28 Nov 2011 12:11:37 +0100

spatialindex (1.4.0-1) unstable; urgency=low

  * New upstream release.
  * Partch gcc43 removed, because merged upstream.
  * Policy bumped to 3.8.3, without changes.

 -- Francesco Paolo Lovergine <frankie@debian.org>  Sat, 12 Sep 2009 10:43:52 +0200

spatialindex (1.3.2-1) unstable; urgency=low

  * Initial release.
    (closes: #530845)

 -- Francesco Paolo Lovergine <frankie@debian.org>  Wed, 27 May 2009 20:29:47 +0200

=== debian/control ===
Source: spatialindex
Priority: extra
Maintainer: Debian GIS Project <pkg-grass-devel@lists.alioth.debian.org>
Uploaders: Francesco Paolo Lovergine <frankie@debian.org>
Build-Depends: debhelper (>= 8), autotools-dev
Standards-Version: 3.9.2
Section: science
Homepage: https://github.com/libspatialindex/libspatialindex
Vcs-Browser: http://git.debian.org/?p=pkg-grass/libspatialindex.git
Vcs-Git: git://git.debian.org/git/pkg-grass/libspatialindex.git

Package: libspatialindex-dev
Section: libdevel
Architecture: any
Depends: libspatialindex1 (= ${binary:Version})
Recommends: pkg-config
Description: A general framework for developing spatial indices
 Spatialindex is a C++ library that provides a framework for
 developing spatial indices. Currently it defines generic interfaces,
 provides simple main memory and disk based storage managers and a
 robust implementation of an R*-tree, an MVR-tree and a TPR-tree.
 .
 This package contains the SpatialIndex shared library.

Package: libspatialindex1
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: A general framework for developing spatial indices - development files
 Spatialindex is a C++ library that provides a framework for
 developing spatial indices. Currently it defines generic interfaces,
 provides simple main memory and disk based storage managers and a
 robust implementation of an R*-tree, an MVR-tree and a TPR-tree.
 .
 This package contains the development files to build third
 parties programs.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1


# These are used for cross-compiling and for saving the configure script
# from having to guess our platform (since we know it already)
DEB_HOST_GNU_TYPE   ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)
DEB_BUILD_GNU_TYPE  ?= $(shell dpkg-architecture -qDEB_BUILD_GNU_TYPE)
ifneq ($(DEB_HOST_GNU_TYPE),$(DEB_BUILD_GNU_TYPE))
CROSS= --build $(DEB_BUILD_GNU_TYPE) --host $(DEB_HOST_GNU_TYPE)
else
CROSS= --build $(DEB_BUILD_GNU_TYPE)
endif

config.status: configure
	dh_testdir
	# Add here commands to configure the package.
ifneq "$(wildcard /usr/share/misc/config.sub)" ""
	cp -f config.sub config.sub.orig
	cp -f /usr/share/misc/config.sub config.sub
endif
ifneq "$(wildcard /usr/share/misc/config.guess)" ""
	cp -f config.guess config.guess.orig
	cp -f /usr/share/misc/config.guess config.guess
endif
	./configure $(CROSS) --prefix=/usr --mandir=\$${prefix}/share/man --infodir=\$${prefix}/share/info \
		CFLAGS="$(CFLAGS)" LDFLAGS="-Wl,-z,defs" \
		CC=g++ # a dirty hack to force using of g++ at libtool linking time

build: build-stamp
build-stamp:  config.status
	dh_testdir
	
	# Add here commands to compile the package.
	$(MAKE) 
	
	touch $@

clean: 
	dh_testdir
	dh_testroot
	rm -f build-stamp 
	
	# Add here commands to clean up after the build process.
	[ ! -f Makefile ] || $(MAKE) distclean
	[ ! -f config.sub.orig ] || mv -f config.sub.orig config.sub
	[ ! -f config.guess.orig ] || mv -f config.guess.orig config.guess
	rm -rf *.log autom4ate.cache
	rm -rf debian/tmp
	
	dh_clean 

install: build
	dh_testdir
	dh_testroot
	dh_prep  
	dh_installdirs
	
	# Add here commands to install the package into debian/tmp
	$(MAKE) DESTDIR=$(CURDIR)/debian/tmp install


# Build architecture-independent files here.
binary-indep: install
# We have nothing to do by default.

# Build architecture-dependent files here.
binary-arch: install
	dh_testdir
	dh_testroot
	dh_installchangelogs ChangeLog
	dh_installdocs
	dh_installexamples
	dh_install --list-missing
	dh_installman
	dh_link
	dh_strip
	dh_compress
	dh_fixperms
	dh_makeshlibs
	dh_installdeb
	dh_shlibdeps
	dh_gencontrol
	dh_md5sums
	dh_builddeb

binary: binary-indep binary-arch
.PHONY: build clean binary-indep binary-arch binary install

=== debian/watch ===
# Compulsory line, this is a version 3 file
version=3
http://trac.gispython.org/spatialindex/wiki/Releases .*spatialindex-src-(.*)\.tar\.gz.*

## spatialindex 1.8.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -24,18 +24,33 @@
 #------------------------------------------------------------------------------
 
 SET(SIDX_VERSION_MAJOR "1")
-SET(SIDX_VERSION_MINOR "7")
-SET(SIDX_VERSION_PATCH "0")
+SET(SIDX_VERSION_MINOR "8")
+SET(SIDX_VERSION_PATCH "1")
+SET(SIDX_LIB_SOVERSION "3.0.0")
+
 
 set(SIDX_VERSION_STRING "${SIDX_VERSION_MAJOR}.${SIDX_VERSION_MINOR}.${SIDX_VERSION_PATCH}")
-SET(SIDX_LIB_SOVERSION ${SIDX_VERSION_MAJOR})
-SET(SIDX_C_LIB_SOVERSION ${SIDX_VERSION_MAJOR})
 
 
 # Name of C++ library
+
 set(SIDX_LIB_NAME spatialindex)
-
 set(SIDX_C_LIB_NAME spatialindex_c)
+
+if(WIN32)
+  if (MSVC)
+    if (MSVC80 OR MSVC90 OR MSVC10)
+        if( CMAKE_SIZEOF_VOID_P EQUAL 8 )
+            set( SIDX_LIB_NAME "spatialindex-64" )
+            set( SIDX_C_LIB_NAME "spatialindex_c-64" )
+        else( CMAKE_SIZEOF_VOID_P EQUAL 8 )
+            set( SIDX_LIB_NAME "spatialindex-32"  )
+            set( SIDX_C_LIB_NAME "spatialindex_c-32"  )
+        endif( CMAKE_SIZEOF_VOID_P EQUAL 8 )
+    endif()
+  endif()
+endif()
+
 
 set(CMAKE_INCLUDE_DIRECTORIES_PROJECT_BEFORE ON)
 
@@ -43,11 +58,14 @@
 
 check_function_exists(srand48 HAVE_SRAND48)
 check_function_exists(gettimeofday HAVE_GETTIMEOFDAY)
-check_function_exists(bzero HAVE_BZERO)
 check_function_exists(memset HAVE_MEMSET)
 check_function_exists(memcpy HAVE_MEMCPY)
 check_function_exists(bcopy HAVE_BCOPY)
 
+INCLUDE (CheckIncludeFiles)
+check_include_files(pthread.h HAVE_PTHREAD_H) 
+
+
 if (HAVE_SRAND48)
     add_definitions(-DHAVE_SRAND48=1)
 endif()
@@ -70,6 +88,10 @@
 
 if (HAVE_BCOPY)
     add_definitions(-DHAVE_BCOPY=1)
+endif()
+
+if (HAVE_PTHREAD_H)
+    add_definitions(-DHAVE_PTHREAD_H=1)
 endif()
 
 # Choose to use pkg-config or not
@@ -83,7 +105,7 @@
 # note we default to debug mode
 if(NOT MSVC_IDE)
   if(NOT CMAKE_BUILD_TYPE)
-  set(CMAKE_BUILD_TYPE Debug CACHE STRING 
+  set(CMAKE_BUILD_TYPE RelWithDebInfo CACHE STRING
     "Choose the type of build, options are: None Debug Release RelWithDebInfo MinSizeRel" FORCE)
   endif()
   message(STATUS "Setting libspatialindex build type - ${CMAKE_BUILD_TYPE}")
@@ -101,7 +123,7 @@
 set(CMAKE_LIBRARY_OUTPUT_DIRECTORY ${SIDX_BUILD_OUTPUT_DIRECTORY})
 
 # Output directory in which to build ARCHIVE target files.
-set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY ${SIDX_BUILD_OUTPUT_DIRECTORY}) 
+set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY ${SIDX_BUILD_OUTPUT_DIRECTORY})
 
 
 #------------------------------------------------------------------------------
@@ -110,7 +132,7 @@
 
 if(WIN32)
   if (MSVC)
-    if (MSVC80 OR MSVC90 OR MSVC10)
+    if (MSVC80 OR MSVC90 OR MSVC10 OR MSVC11)
       add_definitions(-D_CRT_SECURE_NO_DEPRECATE)
       add_definitions(-D_CRT_SECURE_NO_WARNINGS)
       add_definitions(-D_CRT_NONSTDC_NO_WARNING)
@@ -118,7 +140,9 @@
       add_definitions(-DSPATIALINDEX_CREATE_DLL=1)
 
       set(SIDX_COMPILER_MSVC 1)
-      if (MSVC10)
+      if (MSVC11)
+        set(SIDX_COMPILER_VC11 1)
+      elseif (MSVC10)
         set(SIDX_COMPILER_VC10 1)
       elseif (MSVC9)
         set(SIDX_COMPILER_VC9 1)
@@ -126,7 +150,7 @@
         set(SIDX_COMPILER_VC8 1)
       endif()
     endif()
-    
+
     if(CMAKE_CXX_FLAGS MATCHES "/W[0-4]")
       string(REGEX REPLACE "/W[0-4]" "/W4"
         CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS}")
@@ -134,7 +158,7 @@
       set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /W4")
     endif()
   endif()
-  
+
   set(CMAKE_INCLUDE_PATH c:/osgeo4w/include;$ENV{CMAKE_INCLUDE_PATH})
   set(CMAKE_LIBRARY_PATH c:/osgeo4w/lib;$ENV{CMAKE_LIBRARY_PATH})
 
@@ -154,9 +178,9 @@
     if (CMAKE_COMPILER_IS_GNUCXX)
       set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++98 -ansi")
     endif()
-    
+
     set(SIDX_COMPILER_GCC 1)
-    
+
   elseif("${CMAKE_CXX_COMPILER_ID}" MATCHES "Clang" OR "${CMAKE_CXX_COMPILER}" MATCHES "clang")
     set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${SIDX_COMMON_CXX_FLAGS}")
     set(SIDX_COMPILER_CLANG 1)
@@ -191,7 +215,7 @@
   # Common locations for Unix and Mac OS X
   set(DEFAULT_BIN_SUBDIR bin)
   set(DEFAULT_LIB_SUBDIR lib${LIB_SUFFIX})
-  set(DEFAULT_DATA_SUBDIR share/libspatialindex)
+  set(DEFAULT_DATA_SUBDIR share/spatialindex)
   set(DEFAULT_INCLUDE_SUBDIR include)
 endif()
 
@@ -216,7 +240,6 @@
 set(SIDX_INCLUDE_DIR ${SIDX_INCLUDE_SUBDIR})
 set(SIDX_DATA_DIR ${SIDX_DATA_SUBDIR})
 
-
 #------------------------------------------------------------------------------
 # subdirectory controls
 #------------------------------------------------------------------------------
@@ -224,13 +247,3 @@
 add_subdirectory(src)
 add_subdirectory(test)
 
-
-
-
-#------------------------------------------------------------------------------
-# finally, generate the pdal_config.h header
-#------------------------------------------------------------------------------
-# 
-# configure_file(
-#   "${PROJECT_SOURCE_DIR}/pdal_defines.h.in"
-#   "${PROJECT_SOURCE_DIR}/include/pdal/pdal_defines.h")

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -208,7 +208,7 @@
   PROPERTIES SOVERSION "${SIDX_LIB_SOVERSION}" )
 
 set_target_properties(${SIDX_C_LIB_NAME} 
-  PROPERTIES SOVERSION "${SIDX_C_LIB_SOVERSION}" )
+  PROPERTIES SOVERSION "${SIDX_LIB_SOVERSION}" )
 
 
 
@@ -217,6 +217,11 @@
     ${SIDX_LIB_NAME}
     PROPERTIES
     INSTALL_NAME_DIR "${CMAKE_INSTALL_PREFIX}/lib")
+
+  set_target_properties(
+    ${SIDX_C_LIB_NAME}
+    PROPERTIES
+    INSTALL_NAME_DIR "${CMAKE_INSTALL_PREFIX}/lib")
 endif()
 
 ###############################################################################
@@ -228,5 +233,5 @@
   ARCHIVE DESTINATION ${SIDX_LIB_DIR})
 
 install(DIRECTORY ${SIDX_HEADERS_DIR}
-  DESTINATION include/libspatialindex
+  DESTINATION include/spatialindex
   FILES_MATCHING PATTERN "*.h" PATTERN "*.hpp")

=== test/CMakeLists.txt ===
--- 
+++ 
@@ -1,4 +1,14 @@
 include_directories(../include)
+
+set (DIR geometry)
+set (SOURCES 
+        Intersection 
+        )
+
+foreach (test ${SOURCES})
+    add_executable(test-${DIR}-${test} ${DIR}/${test}.cc)
+    target_link_libraries(test-${DIR}-${test} ${SIDX_LIB_NAME})
+endforeach()
 
 set (DIR rtree)
 set (SOURCES

=== debian/changelog ===
spatialindex (1.8.1-2) unstable; urgency=low

  * Update pkg-config patch to remove LDFLAGS from Libs.
    (closes: #735039)

 -- Bas Couwenberg <sebastic@xs4all.nl>  Sun, 12 Jan 2014 14:08:10 +0100

spatialindex (1.8.1-1) unstable; urgency=low

  * New upstream release.
  * Add myself to Uploaders.
  * Update watch file including sepwatch changes.
  * Update Homepage to github documentation instead of code.
  * Use canonical URLs in Vcs-* fields.
  * Change priority from extra to optional.
  * Bump debhelper compatibility to 9.
  * Use minimal dh rules with dh-autoreconf.
    (closes: #734827, #722835)
  * Support Multi-Arch build.
  * Add misc:Depends for libspatialindex-dev.
  * Don't start description synopsis with an article.
  * Change library packages to match SONAME, and use correct description.
    (closes: #642482)
  * Add debug package for the shared library.
  * Update copyright file using copyright-format 1.0.
  * Add lintian override for debian-watch-may-check-gpg-signature,
    upstream doesn't provide signatures for verification.
  * Remove .la files before install.
  * Add symbols files using pkgkde-symbolshelper.
  * Bump Standards-Version to 3.9.5, changes: minimal dh rules, Multi-Arch,
    Vcs-* fields, shared library changes, copyright.
  * Add patch to modernize the build system.
  * Add patch to include linking to libspatialindex in pkg-config file.
    (closes: #679690)

 -- Bas Couwenberg <sebastic@xs4all.nl>  Fri, 10 Jan 2014 20:30:00 +0100

=== debian/control ===
Source: spatialindex
Maintainer: Debian GIS Project <pkg-grass-devel@lists.alioth.debian.org>
Uploaders: Francesco Paolo Lovergine <frankie@debian.org>,
           Bas Couwenberg <sebastic@xs4all.nl>
Section: science
Priority: optional
Build-Depends: debhelper (>= 9),
               autotools-dev,
               dh-autoreconf,
               pkg-kde-tools
Standards-Version: 3.9.5
Vcs-Browser: http://anonscm.debian.org/gitweb/?p=pkg-grass/libspatialindex.git
Vcs-Git: git://anonscm.debian.org/pkg-grass/libspatialindex.git
Homepage: http://libspatialindex.github.io/

Package: libspatialindex3
Architecture: any
Multi-Arch: same
Section: libs
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: General framework for developing spatial indices
 Spatialindex is a C++ library that provides a framework for
 developing spatial indices. Currently it defines generic interfaces,
 provides simple main memory and disk based storage managers and a
 robust implementation of an R*-tree, an MVR-tree and a TPR-tree.
 .
 This package contains the SpatialIndex shared library.

Package: libspatialindex-c3
Architecture: any
Multi-Arch: same
Section: libs
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: General framework for developing spatial indices - C library
 Spatialindex is a C++ library that provides a framework for
 developing spatial indices. Currently it defines generic interfaces,
 provides simple main memory and disk based storage managers and a
 robust implementation of an R*-tree, an MVR-tree and a TPR-tree.
 .
 This package contains the SpatialIndex shared library for C.

Package: libspatialindex-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends: libspatialindex3 (= ${binary:Version}),
         libspatialindex-c3 (= ${binary:Version}),
         ${misc:Depends}
Recommends: pkg-config
Description: General framework for developing spatial indices - development files
 Spatialindex is a C++ library that provides a framework for
 developing spatial indices. Currently it defines generic interfaces,
 provides simple main memory and disk based storage managers and a
 robust implementation of an R*-tree, an MVR-tree and a TPR-tree.
 .
 This package contains the development files to build third
 parties programs.

Package: libspatialindex3-dbg
Architecture: any
Multi-Arch: same
Section: debug
Priority: extra
Depends: libspatialindex3 (= ${binary:Version}),
         libspatialindex-c3 (= ${binary:Version}),
         ${misc:Depends}
Description: General framework for developing spatial indices - debugging symbols
 Spatialindex is a C++ library that provides a framework for
 developing spatial indices. Currently it defines generic interfaces,
 provides simple main memory and disk based storage managers and a
 robust implementation of an R*-tree, an MVR-tree and a TPR-tree.
 .
 This package contains debugging symbols for the libraries.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

# This has to be exported to make some magic below work.
export DH_OPTIONS

# Enable hardening build flags
export DEB_BUILD_MAINT_OPTIONS=hardening=+all

DEB_HOST_MULTIARCH?=$(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

SPATIALINDEX_VERSION = $(shell dpkg-parsechangelog | sed -ne 's/^Version: \(.*\)-.*/\1/p' | sed -e 's/^\(.*\)~.*/\1/' | sed -e 's/dev.*/.0/')

%:
	dh $@ --with autoreconf,pkgkde_symbolshelper

override_dh_install:
	$(RM) $(CURDIR)/debian/tmp/usr/lib/*/*.la

	dh_install --autodest --list-missing

override_dh_makeshlibs:
	dh_makeshlibs -- -c0 -v$(SPATIALINDEX_VERSION)

override_dh_strip:
	dh_strip --dbg-package=libspatialindex3-dbg
